#!/bin/bash
#print_waypoints_0.1x.sh
#------------------------------------------------------------------------------
#   Dave's GPS bash script is used to reformat waypoint ".gpx" files to a 
#   print friendly version by replacing or removing unnecessary html tags.
#
#   COPYRIGHT:
#   Yeah Right! - (do what you like with it) but ...
#   This code comes with ABSOLUTELY NO WARRANTY.
#   It is open source and is released under the GPL
#   See: http://www.gnu.org/licenses/gpl.txt for full details.
#
#   IDEAS & COMMENTS:
#   This script was developed form ideas gleaned from many sources,
#   I don't claim to be any sort of guru and I would welcome any
#   sugestions, comments or improvements to: dave at 9gerkin9@gmail.com
#
#   TESTED ON:
#   The script has been used successfully on EeePC with the following OS's
#   1.  CrunchBang 9.04.01 Linux, kernel 2.6.28-16-generic
#
#   & Desktop PC with the following OS's
#   1.  Ubuntu 9.10 Linux desktop edition, kernel 2.6.31-15-generic
#
#   DEPENDENCIES:
#   1. 
#
#   CREDITS:
#
#
filename=$HOME/bin/print_waypoints_0.15.sh
version="Verson 0.15 - testing - 21 Dec 09"
#
#==============================================================================
#==================	  SET YOUR USER VARIBLES IN THIS SECTION	===============
#==============================================================================

#   Local folders where files are stored:
#  (the default locations here probably wont need to be changed)
gps=$HOME/GPS
gpc=$HOME/GPS/gcmtache
gpo=$HOME/GPS/osm
gpi=$HOME/GPS/print
gpr=$HOME/GPS/routes
gpn=$HOME/GPS/tango
gpt=$HOME/GPS/temp
gpk=$HOME/GPS/tracks
gpu=$HOME/GPS/upload
gpw=$HOME/GPS/waypoints
gpp=$HOME/GPS/WP
bin=$HOME/bin

prtwpt=print_wpts-`date +%M`			# final printable output file

#==============================================================================
#===================	DON'T EDIT BELOW THIS LINE		=======================
#==============================================================================

#   check for newest file in upload directory:
	newupl=`ls -tr $gpu/*.gpx | tail -1`    # newest file in upload directory
	header=$gpi/header.txt
	outfile=$gpi/outfile.txt

#   grep waypoint or route details:
if [ -f "$newupl" ]; then
	gwpt=`grep "<wpt" $newupl -c`       							  # count waypoints
	grpt=`grep "<rtept" $newupl -c`       							  # count routepoints
	gnme=`grep "<name>" $newupl | cut -d ">" -f 2 | cut -d "<" -f 1`  # short name
	gdsc=`grep "<desc>" $newupl | cut -d ">" -f 2 | cut -d "<" -f 1`  # description
	gfrm=`grep "Freshmap" $newupl -c` 								  # Freshmap output file
	gbab=`grep "GPSBabel" $newupl -c`								  # GPSBabel output file
else
	echo -e "\n\t> > > No waypoint or route file in \"~/GPS/print\" < < <\n"; exit 0
fi

#	grep the header information:
if [ "$gfrm" -gt "1" ]; then
#	adjust output for Freshmap ".gpx" file:
	gdte=`head -6 $newupl | grep "<time>" | cut -d ">" -f 2 | cut -d "<" -f 1`	# date
	gnme=`head -6 $newupl | grep "<name>" | cut -d ">" -f 2 | cut -d "<" -f 1`	# name
	gdsc=`head -6 $newupl | grep "<desc>" | cut -d ">" -f 2 | cut -d "<" -f 1`  # desc
	gcmt=`head -6 $newupl | grep "<cmt>"  | cut -d ">" -f 2 | cut -d "<" -f 1` # comment
else
#	adjust output for GPSBabel ".gpx" file:
	gdte=`head -10 $newupl | grep "<time>" | cut -d ">" -f 2 | cut -d "<" -f 1`	# date
	gnme=`head -10 $newupl | grep "<name>" | cut -d ">" -f 2 | cut -d "<" -f 1`	# name
	gdsc=`head -10 $newupl | grep "<desc>" | cut -d ">" -f 2 | cut -d "<" -f 1` # desc
	gcmt=`head -10 $newupl | grep "<cmt>"  | cut -d ">" -f 2 | cut -d "<" -f 1` # comment
fi

#   create a header file route details grep'd above:
if [ "$grpt" -gt "1" ]; then
	echo "============ NAVIGATION ROUTE =========" >> $header
	echo "Created:      $gdte" >> $header
	echo "Printed:      `date +%d-%b-%Y`" >> $header
	echo "Filename:     \"`basename $newupl`\"" >> $header
	echo "Routename:    $gnme" >> $header
	echo "Description:  $gdsc" >> $header
	echo "Comment:      $gcmt" >> $header
	echo "Routepoints:  $grpt" >> $header
	echo "Distance: " >> $header
	echo "=====================================" >> $header; echo >> $header
else
	echo "=============== WAYPOINTS =============" >> $header
	echo "Created:      $gdte" >> $header
	echo "Printed:      `date +%d-%b-%Y`" >> $header
	echo "Filename:     \"`basename $newupl`\"" >> $header
	echo "Description:  $gdsc" >> $header
	echo "Comment:      $gcmt" >> $header
	echo "Waypoints:    $gwpt" >> $header
	echo "=====================================" >> $header; echo >> $header
fi

#	adjust output for Freshmap ".gpx" file:
if [ "$gfrm" -gt "1" ]; then
	cat $newupl | sed -e '1,2d' $newupl -e '/Freshmap/d' -e '/extensions/d' -e 's|<wpt|Waypoint:    |' -e 's/">/"/' -e 's|<rtept|Routepoint:  |' -e 's/">/"/' -e 's|<ele>|   Elevation: |' -e 's|</ele>| m|' -e 's|<name>|   Name:      |' -e 's|</name>||' -e 's|<cmt>|   Comment:   |' -e 's|</cmt>||' -e '/<desc>/d' -e 's|<sym>|   Symbol:    |' -e 's|</sym>||' -e 's|<type>|   Symbol:    |' -e 's|</type>||' -e 's|</wpt>||' -e 's|</rtept>||' -e '/gpx>/d' -e '/root>/d' -e '/rte>/d' -e '$d' -e 's|&apos;|`|' > $outfile
else
#	adjust output for GPSBabel ".gpx" file:
	cat $newupl | sed -e '1,9d' $newupl -e '/bounds/d' -e 's|<wpt|Waypoint:    |' -e 's/">/"/' -e 's|<ele>| Elevation: |' -e 's|</ele>| m|' -e 's|<name>| Name:      |' -e 's|</name>||' -e 's|<cmt>| Comment:   |' -e 's|</cmt>||' -e '/<desc>/d' -e 's|<sym>| Symbol:    |' -e 's|</sym>||' -e 's|</wpt>||' -e '/gpx>/d' -e '/rte>/d' > $outfile
fi

#	combine the header and the printable waypoints and output
#	and remove duplicate lines:
if [ "$grpt" -gt "1" ]; then
	cd $gpi; cat $header $outfile | sed -e '12,15d' > $prtwpt #<<<<STILL NEEDS TESTING HERE
else
	cd $gpi; cat $header $outfile | sed -e '10,11s/Comment:/DELETE/' -e '10,11s/<time>/DELETE/' -e '/DELETE/d' > $prtwpt
#	cd $gpi; cat $header $outfile > $prtwpt
fi

#   Cleaning up - remove the temp waypoint & header files & report completion:
rm -rf $outfile; rm -rf $header &&
#	echo -e "\n\t\"$outfile\" - created"
#	echo -e "\n\tFinished\n"

exit 0

